# IO.Swagger.Api.QuotesApi

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetV5QuotesDetails**](QuotesApi.md#getv5quotesdetails) | **GET** /quotes/{quoteNumber} | Get quote details
[**PostV5QuotesSearch**](QuotesApi.md#postv5quotessearch) | **POST** /quotes/search | Search quotes

<a name="getv5quotesdetails"></a>
# **GetV5QuotesDetails**
> QuoteDetails GetV5QuotesDetails (string quoteNumber, string customerNumber, string isoCountryCode, string thirdPartySource = null)

Get quote details

The quote detail API will provide all quote details associated with the quote number provided in the call.  *NOTE: quoteNumber, isoCountryCode and customerNumber is mandatory.*

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetV5QuotesDetailsExample
    {
        public void main()
        {
            // Configure OAuth2 access token for authorization: application
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QuotesApi();
            var quoteNumber = quoteNumber_example;  // string | Ingram Micro Quote Number
            var customerNumber = customerNumber_example;  // string | Your Ingram Micro unique customer number (default to 20-222222)
            var isoCountryCode = isoCountryCode_example;  // string |  (default to US)
            var thirdPartySource = thirdPartySource_example;  // string | Unique identifier used to identify the third party source accessing the services (optional)  (default to customer)

            try
            {
                // Get quote details
                QuoteDetails result = apiInstance.GetV5QuotesDetails(quoteNumber, customerNumber, isoCountryCode, thirdPartySource);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QuotesApi.GetV5QuotesDetails: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **quoteNumber** | **string**| Ingram Micro Quote Number | 
 **customerNumber** | **string**| Your Ingram Micro unique customer number | [default to 20-222222]
 **isoCountryCode** | **string**|  | [default to US]
 **thirdPartySource** | **string**| Unique identifier used to identify the third party source accessing the services | [optional] [default to customer]

### Return type

[**QuoteDetails**](QuoteDetails.md)

### Authorization

[application](../README.md#application)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="postv5quotessearch"></a>
# **PostV5QuotesSearch**
> QuoteListResponse PostV5QuotesSearch (QuoteListRequest body = null)

Search quotes

The endpoint, by default, will retrieve quotes modified or created within the last 30 days Quotes older than 365 days are excluded by default. The date filters enable the retrieval of quotes older than 30 days and up to 365 days when using date range criteria.  The endpoint enables the retrieval and filtering of relevant quote list key criteria data such as Quote Number, Special Bid Numbers, End User Name, Quote Status, and Date Ranges from Ingram Micro's CRM system. Only Active quotes are avaiable through the API. Draft and Closed quotes are excluded and are not accessable through the this API. 

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PostV5QuotesSearchExample
    {
        public void main()
        {
            // Configure OAuth2 access token for authorization: application
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QuotesApi();
            var body = new QuoteListRequest(); // QuoteListRequest |  (optional) 

            try
            {
                // Search quotes
                QuoteListResponse result = apiInstance.PostV5QuotesSearch(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QuotesApi.PostV5QuotesSearch: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**QuoteListRequest**](QuoteListRequest.md)|  | [optional] 

### Return type

[**QuoteListResponse**](QuoteListResponse.md)

### Authorization

[application](../README.md#application)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
