/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Response schema for quote details
    /// </summary>
    [DataContract]
        public partial class QuoteDetails :  IEquatable<QuoteDetails>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetails" /> class.
        /// </summary>
        /// <param name="quoteDetailResponse">quoteDetailResponse.</param>
        public QuoteDetails(QuoteDetailsQuoteDetailResponse quoteDetailResponse = default(QuoteDetailsQuoteDetailResponse))
        {
            this.QuoteDetailResponse = quoteDetailResponse;
        }
        
        /// <summary>
        /// Gets or Sets QuoteDetailResponse
        /// </summary>
        [DataMember(Name="quoteDetailResponse", EmitDefaultValue=false)]
        public QuoteDetailsQuoteDetailResponse QuoteDetailResponse { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetails {\n");
            sb.Append("  QuoteDetailResponse: ").Append(QuoteDetailResponse).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetails);
        }

        /// <summary>
        /// Returns true if QuoteDetails instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetails to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetails input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.QuoteDetailResponse == input.QuoteDetailResponse ||
                    (this.QuoteDetailResponse != null &&
                    this.QuoteDetailResponse.Equals(input.QuoteDetailResponse))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.QuoteDetailResponse != null)
                    hashCode = hashCode * 59 + this.QuoteDetailResponse.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
