/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteDetailsQuoteDetailResponse
    /// </summary>
    [DataContract]
        public partial class QuoteDetailsQuoteDetailResponse :  IEquatable<QuoteDetailsQuoteDetailResponse>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetailsQuoteDetailResponse" /> class.
        /// </summary>
        /// <param name="responsePreamble">responsePreamble.</param>
        /// <param name="retrieveQuoteResponse">retrieveQuoteResponse.</param>
        /// <param name="quoteProductList">quoteProductList.</param>
        /// <param name="totalQuoteProductCount">totalQuoteProductCount.</param>
        /// <param name="totalExtendedMsrp">totalExtendedMsrp.</param>
        /// <param name="totalQuantity">totalQuantity.</param>
        /// <param name="totalExtendedQuotePrice">totalExtendedQuotePrice.</param>
        public QuoteDetailsQuoteDetailResponse(QuoteDetailsQuoteDetailResponseResponsePreamble responsePreamble = default(QuoteDetailsQuoteDetailResponseResponsePreamble), QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse retrieveQuoteResponse = default(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse), List<QuoteProductList> quoteProductList = default(List<QuoteProductList>), string totalQuoteProductCount = default(string), string totalExtendedMsrp = default(string), int? totalQuantity = default(int?), string totalExtendedQuotePrice = default(string))
        {
            this.ResponsePreamble = responsePreamble;
            this.RetrieveQuoteResponse = retrieveQuoteResponse;
            this.QuoteProductList = quoteProductList;
            this.TotalQuoteProductCount = totalQuoteProductCount;
            this.TotalExtendedMsrp = totalExtendedMsrp;
            this.TotalQuantity = totalQuantity;
            this.TotalExtendedQuotePrice = totalExtendedQuotePrice;
        }
        
        /// <summary>
        /// Gets or Sets ResponsePreamble
        /// </summary>
        [DataMember(Name="responsePreamble", EmitDefaultValue=false)]
        public QuoteDetailsQuoteDetailResponseResponsePreamble ResponsePreamble { get; set; }

        /// <summary>
        /// Gets or Sets RetrieveQuoteResponse
        /// </summary>
        [DataMember(Name="retrieveQuoteResponse", EmitDefaultValue=false)]
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse RetrieveQuoteResponse { get; set; }

        /// <summary>
        /// Gets or Sets QuoteProductList
        /// </summary>
        [DataMember(Name="quoteProductList", EmitDefaultValue=false)]
        public List<QuoteProductList> QuoteProductList { get; set; }

        /// <summary>
        /// Gets or Sets TotalQuoteProductCount
        /// </summary>
        [DataMember(Name="totalQuoteProductCount", EmitDefaultValue=false)]
        public string TotalQuoteProductCount { get; set; }

        /// <summary>
        /// Gets or Sets TotalExtendedMsrp
        /// </summary>
        [DataMember(Name="totalExtendedMsrp", EmitDefaultValue=false)]
        public string TotalExtendedMsrp { get; set; }

        /// <summary>
        /// Gets or Sets TotalQuantity
        /// </summary>
        [DataMember(Name="totalQuantity", EmitDefaultValue=false)]
        public int? TotalQuantity { get; set; }

        /// <summary>
        /// Gets or Sets TotalExtendedQuotePrice
        /// </summary>
        [DataMember(Name="totalExtendedQuotePrice", EmitDefaultValue=false)]
        public string TotalExtendedQuotePrice { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetailsQuoteDetailResponse {\n");
            sb.Append("  ResponsePreamble: ").Append(ResponsePreamble).Append("\n");
            sb.Append("  RetrieveQuoteResponse: ").Append(RetrieveQuoteResponse).Append("\n");
            sb.Append("  QuoteProductList: ").Append(QuoteProductList).Append("\n");
            sb.Append("  TotalQuoteProductCount: ").Append(TotalQuoteProductCount).Append("\n");
            sb.Append("  TotalExtendedMsrp: ").Append(TotalExtendedMsrp).Append("\n");
            sb.Append("  TotalQuantity: ").Append(TotalQuantity).Append("\n");
            sb.Append("  TotalExtendedQuotePrice: ").Append(TotalExtendedQuotePrice).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetailsQuoteDetailResponse);
        }

        /// <summary>
        /// Returns true if QuoteDetailsQuoteDetailResponse instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetailsQuoteDetailResponse to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetailsQuoteDetailResponse input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ResponsePreamble == input.ResponsePreamble ||
                    (this.ResponsePreamble != null &&
                    this.ResponsePreamble.Equals(input.ResponsePreamble))
                ) && 
                (
                    this.RetrieveQuoteResponse == input.RetrieveQuoteResponse ||
                    (this.RetrieveQuoteResponse != null &&
                    this.RetrieveQuoteResponse.Equals(input.RetrieveQuoteResponse))
                ) && 
                (
                    this.QuoteProductList == input.QuoteProductList ||
                    this.QuoteProductList != null &&
                    input.QuoteProductList != null &&
                    this.QuoteProductList.SequenceEqual(input.QuoteProductList)
                ) && 
                (
                    this.TotalQuoteProductCount == input.TotalQuoteProductCount ||
                    (this.TotalQuoteProductCount != null &&
                    this.TotalQuoteProductCount.Equals(input.TotalQuoteProductCount))
                ) && 
                (
                    this.TotalExtendedMsrp == input.TotalExtendedMsrp ||
                    (this.TotalExtendedMsrp != null &&
                    this.TotalExtendedMsrp.Equals(input.TotalExtendedMsrp))
                ) && 
                (
                    this.TotalQuantity == input.TotalQuantity ||
                    (this.TotalQuantity != null &&
                    this.TotalQuantity.Equals(input.TotalQuantity))
                ) && 
                (
                    this.TotalExtendedQuotePrice == input.TotalExtendedQuotePrice ||
                    (this.TotalExtendedQuotePrice != null &&
                    this.TotalExtendedQuotePrice.Equals(input.TotalExtendedQuotePrice))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ResponsePreamble != null)
                    hashCode = hashCode * 59 + this.ResponsePreamble.GetHashCode();
                if (this.RetrieveQuoteResponse != null)
                    hashCode = hashCode * 59 + this.RetrieveQuoteResponse.GetHashCode();
                if (this.QuoteProductList != null)
                    hashCode = hashCode * 59 + this.QuoteProductList.GetHashCode();
                if (this.TotalQuoteProductCount != null)
                    hashCode = hashCode * 59 + this.TotalQuoteProductCount.GetHashCode();
                if (this.TotalExtendedMsrp != null)
                    hashCode = hashCode * 59 + this.TotalExtendedMsrp.GetHashCode();
                if (this.TotalQuantity != null)
                    hashCode = hashCode * 59 + this.TotalQuantity.GetHashCode();
                if (this.TotalExtendedQuotePrice != null)
                    hashCode = hashCode * 59 + this.TotalExtendedQuotePrice.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
