/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse
    /// </summary>
    [DataContract]
        public partial class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse :  IEquatable<QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse" /> class.
        /// </summary>
        /// <param name="quoteGuid">quoteGuid.</param>
        /// <param name="quoteName">quoteName.</param>
        /// <param name="quoteNumber">quoteNumber.</param>
        /// <param name="quoteExpiryDate">quoteExpiryDate.</param>
        /// <param name="revisionNumber">revisionNumber.</param>
        /// <param name="introPreamble">introPreamble.</param>
        /// <param name="purchaseInstructions">purchaseInstructions.</param>
        /// <param name="legalTerms">legalTerms.</param>
        /// <param name="currencyCode">currencyCode.</param>
        /// <param name="priceDeviationId">priceDeviationId.</param>
        /// <param name="priceDeviationStartDate">priceDeviationStartDate.</param>
        /// <param name="priceDeviationExpiryDate">priceDeviationExpiryDate.</param>
        /// <param name="customerNeed">customerNeed.</param>
        /// <param name="solutionProposed">solutionProposed.</param>
        /// <param name="status">status.</param>
        /// <param name="created">created.</param>
        /// <param name="modified">modified.</param>
        /// <param name="leasingCalculations">leasingCalculations.</param>
        /// <param name="leasingInstructions">leasingInstructions.</param>
        /// <param name="accountInfo">accountInfo.</param>
        /// <param name="contactInfo">contactInfo.</param>
        /// <param name="vendorAttributes">vendorAttributes.</param>
        /// <param name="endUser">endUser.</param>
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse(string quoteGuid = default(string), string quoteName = default(string), string quoteNumber = default(string), DateTime? quoteExpiryDate = default(DateTime?), string revisionNumber = default(string), string introPreamble = default(string), string purchaseInstructions = default(string), string legalTerms = default(string), string currencyCode = default(string), string priceDeviationId = default(string), DateTime? priceDeviationStartDate = default(DateTime?), DateTime? priceDeviationExpiryDate = default(DateTime?), string customerNeed = default(string), string solutionProposed = default(string), string status = default(string), DateTime? created = default(DateTime?), DateTime? modified = default(DateTime?), string leasingCalculations = default(string), string leasingInstructions = default(string), QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo accountInfo = default(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo), QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo contactInfo = default(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo), QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes vendorAttributes = default(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes), QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser endUser = default(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser))
        {
            this.QuoteGuid = quoteGuid;
            this.QuoteName = quoteName;
            this.QuoteNumber = quoteNumber;
            this.QuoteExpiryDate = quoteExpiryDate;
            this.RevisionNumber = revisionNumber;
            this.IntroPreamble = introPreamble;
            this.PurchaseInstructions = purchaseInstructions;
            this.LegalTerms = legalTerms;
            this.CurrencyCode = currencyCode;
            this.PriceDeviationId = priceDeviationId;
            this.PriceDeviationStartDate = priceDeviationStartDate;
            this.PriceDeviationExpiryDate = priceDeviationExpiryDate;
            this.CustomerNeed = customerNeed;
            this.SolutionProposed = solutionProposed;
            this.Status = status;
            this.Created = created;
            this.Modified = modified;
            this.LeasingCalculations = leasingCalculations;
            this.LeasingInstructions = leasingInstructions;
            this.AccountInfo = accountInfo;
            this.ContactInfo = contactInfo;
            this.VendorAttributes = vendorAttributes;
            this.EndUser = endUser;
        }
        
        /// <summary>
        /// Gets or Sets QuoteGuid
        /// </summary>
        [DataMember(Name="quoteGuid", EmitDefaultValue=false)]
        public string QuoteGuid { get; set; }

        /// <summary>
        /// Gets or Sets QuoteName
        /// </summary>
        [DataMember(Name="quoteName", EmitDefaultValue=false)]
        public string QuoteName { get; set; }

        /// <summary>
        /// Gets or Sets QuoteNumber
        /// </summary>
        [DataMember(Name="quoteNumber", EmitDefaultValue=false)]
        public string QuoteNumber { get; set; }

        /// <summary>
        /// Gets or Sets QuoteExpiryDate
        /// </summary>
        [DataMember(Name="quoteExpiryDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? QuoteExpiryDate { get; set; }

        /// <summary>
        /// Gets or Sets RevisionNumber
        /// </summary>
        [DataMember(Name="revisionNumber", EmitDefaultValue=false)]
        public string RevisionNumber { get; set; }

        /// <summary>
        /// Gets or Sets IntroPreamble
        /// </summary>
        [DataMember(Name="introPreamble", EmitDefaultValue=false)]
        public string IntroPreamble { get; set; }

        /// <summary>
        /// Gets or Sets PurchaseInstructions
        /// </summary>
        [DataMember(Name="purchaseInstructions", EmitDefaultValue=false)]
        public string PurchaseInstructions { get; set; }

        /// <summary>
        /// Gets or Sets LegalTerms
        /// </summary>
        [DataMember(Name="legalTerms", EmitDefaultValue=false)]
        public string LegalTerms { get; set; }

        /// <summary>
        /// Gets or Sets CurrencyCode
        /// </summary>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Gets or Sets PriceDeviationId
        /// </summary>
        [DataMember(Name="priceDeviationId", EmitDefaultValue=false)]
        public string PriceDeviationId { get; set; }

        /// <summary>
        /// Gets or Sets PriceDeviationStartDate
        /// </summary>
        [DataMember(Name="priceDeviationStartDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? PriceDeviationStartDate { get; set; }

        /// <summary>
        /// Gets or Sets PriceDeviationExpiryDate
        /// </summary>
        [DataMember(Name="priceDeviationExpiryDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? PriceDeviationExpiryDate { get; set; }

        /// <summary>
        /// Gets or Sets CustomerNeed
        /// </summary>
        [DataMember(Name="customerNeed", EmitDefaultValue=false)]
        public string CustomerNeed { get; set; }

        /// <summary>
        /// Gets or Sets SolutionProposed
        /// </summary>
        [DataMember(Name="solutionProposed", EmitDefaultValue=false)]
        public string SolutionProposed { get; set; }

        /// <summary>
        /// Gets or Sets Status
        /// </summary>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public string Status { get; set; }

        /// <summary>
        /// Gets or Sets Created
        /// </summary>
        [DataMember(Name="created", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? Created { get; set; }

        /// <summary>
        /// Gets or Sets Modified
        /// </summary>
        [DataMember(Name="modified", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? Modified { get; set; }

        /// <summary>
        /// Gets or Sets LeasingCalculations
        /// </summary>
        [DataMember(Name="leasingCalculations", EmitDefaultValue=false)]
        public string LeasingCalculations { get; set; }

        /// <summary>
        /// Gets or Sets LeasingInstructions
        /// </summary>
        [DataMember(Name="leasingInstructions", EmitDefaultValue=false)]
        public string LeasingInstructions { get; set; }

        /// <summary>
        /// Gets or Sets AccountInfo
        /// </summary>
        [DataMember(Name="accountInfo", EmitDefaultValue=false)]
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo AccountInfo { get; set; }

        /// <summary>
        /// Gets or Sets ContactInfo
        /// </summary>
        [DataMember(Name="contactInfo", EmitDefaultValue=false)]
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo ContactInfo { get; set; }

        /// <summary>
        /// Gets or Sets VendorAttributes
        /// </summary>
        [DataMember(Name="vendorAttributes", EmitDefaultValue=false)]
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes VendorAttributes { get; set; }

        /// <summary>
        /// Gets or Sets EndUser
        /// </summary>
        [DataMember(Name="endUser", EmitDefaultValue=false)]
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser EndUser { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse {\n");
            sb.Append("  QuoteGuid: ").Append(QuoteGuid).Append("\n");
            sb.Append("  QuoteName: ").Append(QuoteName).Append("\n");
            sb.Append("  QuoteNumber: ").Append(QuoteNumber).Append("\n");
            sb.Append("  QuoteExpiryDate: ").Append(QuoteExpiryDate).Append("\n");
            sb.Append("  RevisionNumber: ").Append(RevisionNumber).Append("\n");
            sb.Append("  IntroPreamble: ").Append(IntroPreamble).Append("\n");
            sb.Append("  PurchaseInstructions: ").Append(PurchaseInstructions).Append("\n");
            sb.Append("  LegalTerms: ").Append(LegalTerms).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  PriceDeviationId: ").Append(PriceDeviationId).Append("\n");
            sb.Append("  PriceDeviationStartDate: ").Append(PriceDeviationStartDate).Append("\n");
            sb.Append("  PriceDeviationExpiryDate: ").Append(PriceDeviationExpiryDate).Append("\n");
            sb.Append("  CustomerNeed: ").Append(CustomerNeed).Append("\n");
            sb.Append("  SolutionProposed: ").Append(SolutionProposed).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  Created: ").Append(Created).Append("\n");
            sb.Append("  Modified: ").Append(Modified).Append("\n");
            sb.Append("  LeasingCalculations: ").Append(LeasingCalculations).Append("\n");
            sb.Append("  LeasingInstructions: ").Append(LeasingInstructions).Append("\n");
            sb.Append("  AccountInfo: ").Append(AccountInfo).Append("\n");
            sb.Append("  ContactInfo: ").Append(ContactInfo).Append("\n");
            sb.Append("  VendorAttributes: ").Append(VendorAttributes).Append("\n");
            sb.Append("  EndUser: ").Append(EndUser).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse);
        }

        /// <summary>
        /// Returns true if QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.QuoteGuid == input.QuoteGuid ||
                    (this.QuoteGuid != null &&
                    this.QuoteGuid.Equals(input.QuoteGuid))
                ) && 
                (
                    this.QuoteName == input.QuoteName ||
                    (this.QuoteName != null &&
                    this.QuoteName.Equals(input.QuoteName))
                ) && 
                (
                    this.QuoteNumber == input.QuoteNumber ||
                    (this.QuoteNumber != null &&
                    this.QuoteNumber.Equals(input.QuoteNumber))
                ) && 
                (
                    this.QuoteExpiryDate == input.QuoteExpiryDate ||
                    (this.QuoteExpiryDate != null &&
                    this.QuoteExpiryDate.Equals(input.QuoteExpiryDate))
                ) && 
                (
                    this.RevisionNumber == input.RevisionNumber ||
                    (this.RevisionNumber != null &&
                    this.RevisionNumber.Equals(input.RevisionNumber))
                ) && 
                (
                    this.IntroPreamble == input.IntroPreamble ||
                    (this.IntroPreamble != null &&
                    this.IntroPreamble.Equals(input.IntroPreamble))
                ) && 
                (
                    this.PurchaseInstructions == input.PurchaseInstructions ||
                    (this.PurchaseInstructions != null &&
                    this.PurchaseInstructions.Equals(input.PurchaseInstructions))
                ) && 
                (
                    this.LegalTerms == input.LegalTerms ||
                    (this.LegalTerms != null &&
                    this.LegalTerms.Equals(input.LegalTerms))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.PriceDeviationId == input.PriceDeviationId ||
                    (this.PriceDeviationId != null &&
                    this.PriceDeviationId.Equals(input.PriceDeviationId))
                ) && 
                (
                    this.PriceDeviationStartDate == input.PriceDeviationStartDate ||
                    (this.PriceDeviationStartDate != null &&
                    this.PriceDeviationStartDate.Equals(input.PriceDeviationStartDate))
                ) && 
                (
                    this.PriceDeviationExpiryDate == input.PriceDeviationExpiryDate ||
                    (this.PriceDeviationExpiryDate != null &&
                    this.PriceDeviationExpiryDate.Equals(input.PriceDeviationExpiryDate))
                ) && 
                (
                    this.CustomerNeed == input.CustomerNeed ||
                    (this.CustomerNeed != null &&
                    this.CustomerNeed.Equals(input.CustomerNeed))
                ) && 
                (
                    this.SolutionProposed == input.SolutionProposed ||
                    (this.SolutionProposed != null &&
                    this.SolutionProposed.Equals(input.SolutionProposed))
                ) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                ) && 
                (
                    this.Created == input.Created ||
                    (this.Created != null &&
                    this.Created.Equals(input.Created))
                ) && 
                (
                    this.Modified == input.Modified ||
                    (this.Modified != null &&
                    this.Modified.Equals(input.Modified))
                ) && 
                (
                    this.LeasingCalculations == input.LeasingCalculations ||
                    (this.LeasingCalculations != null &&
                    this.LeasingCalculations.Equals(input.LeasingCalculations))
                ) && 
                (
                    this.LeasingInstructions == input.LeasingInstructions ||
                    (this.LeasingInstructions != null &&
                    this.LeasingInstructions.Equals(input.LeasingInstructions))
                ) && 
                (
                    this.AccountInfo == input.AccountInfo ||
                    (this.AccountInfo != null &&
                    this.AccountInfo.Equals(input.AccountInfo))
                ) && 
                (
                    this.ContactInfo == input.ContactInfo ||
                    (this.ContactInfo != null &&
                    this.ContactInfo.Equals(input.ContactInfo))
                ) && 
                (
                    this.VendorAttributes == input.VendorAttributes ||
                    (this.VendorAttributes != null &&
                    this.VendorAttributes.Equals(input.VendorAttributes))
                ) && 
                (
                    this.EndUser == input.EndUser ||
                    (this.EndUser != null &&
                    this.EndUser.Equals(input.EndUser))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.QuoteGuid != null)
                    hashCode = hashCode * 59 + this.QuoteGuid.GetHashCode();
                if (this.QuoteName != null)
                    hashCode = hashCode * 59 + this.QuoteName.GetHashCode();
                if (this.QuoteNumber != null)
                    hashCode = hashCode * 59 + this.QuoteNumber.GetHashCode();
                if (this.QuoteExpiryDate != null)
                    hashCode = hashCode * 59 + this.QuoteExpiryDate.GetHashCode();
                if (this.RevisionNumber != null)
                    hashCode = hashCode * 59 + this.RevisionNumber.GetHashCode();
                if (this.IntroPreamble != null)
                    hashCode = hashCode * 59 + this.IntroPreamble.GetHashCode();
                if (this.PurchaseInstructions != null)
                    hashCode = hashCode * 59 + this.PurchaseInstructions.GetHashCode();
                if (this.LegalTerms != null)
                    hashCode = hashCode * 59 + this.LegalTerms.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.PriceDeviationId != null)
                    hashCode = hashCode * 59 + this.PriceDeviationId.GetHashCode();
                if (this.PriceDeviationStartDate != null)
                    hashCode = hashCode * 59 + this.PriceDeviationStartDate.GetHashCode();
                if (this.PriceDeviationExpiryDate != null)
                    hashCode = hashCode * 59 + this.PriceDeviationExpiryDate.GetHashCode();
                if (this.CustomerNeed != null)
                    hashCode = hashCode * 59 + this.CustomerNeed.GetHashCode();
                if (this.SolutionProposed != null)
                    hashCode = hashCode * 59 + this.SolutionProposed.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                if (this.Created != null)
                    hashCode = hashCode * 59 + this.Created.GetHashCode();
                if (this.Modified != null)
                    hashCode = hashCode * 59 + this.Modified.GetHashCode();
                if (this.LeasingCalculations != null)
                    hashCode = hashCode * 59 + this.LeasingCalculations.GetHashCode();
                if (this.LeasingInstructions != null)
                    hashCode = hashCode * 59 + this.LeasingInstructions.GetHashCode();
                if (this.AccountInfo != null)
                    hashCode = hashCode * 59 + this.AccountInfo.GetHashCode();
                if (this.ContactInfo != null)
                    hashCode = hashCode * 59 + this.ContactInfo.GetHashCode();
                if (this.VendorAttributes != null)
                    hashCode = hashCode * 59 + this.VendorAttributes.GetHashCode();
                if (this.EndUser != null)
                    hashCode = hashCode * 59 + this.EndUser.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
