/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo
    /// </summary>
    [DataContract]
        public partial class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo :  IEquatable<QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo" /> class.
        /// </summary>
        /// <param name="accountName">accountName.</param>
        /// <param name="bcn">bcn.</param>
        /// <param name="phone">phone.</param>
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo(string accountName = default(string), string bcn = default(string), string phone = default(string))
        {
            this.AccountName = accountName;
            this.Bcn = bcn;
            this.Phone = phone;
        }
        
        /// <summary>
        /// Gets or Sets AccountName
        /// </summary>
        [DataMember(Name="accountName", EmitDefaultValue=false)]
        public string AccountName { get; set; }

        /// <summary>
        /// Gets or Sets Bcn
        /// </summary>
        [DataMember(Name="bcn", EmitDefaultValue=false)]
        public string Bcn { get; set; }

        /// <summary>
        /// Gets or Sets Phone
        /// </summary>
        [DataMember(Name="phone", EmitDefaultValue=false)]
        public string Phone { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo {\n");
            sb.Append("  AccountName: ").Append(AccountName).Append("\n");
            sb.Append("  Bcn: ").Append(Bcn).Append("\n");
            sb.Append("  Phone: ").Append(Phone).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo);
        }

        /// <summary>
        /// Returns true if QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.AccountName == input.AccountName ||
                    (this.AccountName != null &&
                    this.AccountName.Equals(input.AccountName))
                ) && 
                (
                    this.Bcn == input.Bcn ||
                    (this.Bcn != null &&
                    this.Bcn.Equals(input.Bcn))
                ) && 
                (
                    this.Phone == input.Phone ||
                    (this.Phone != null &&
                    this.Phone.Equals(input.Phone))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AccountName != null)
                    hashCode = hashCode * 59 + this.AccountName.GetHashCode();
                if (this.Bcn != null)
                    hashCode = hashCode * 59 + this.Bcn.GetHashCode();
                if (this.Phone != null)
                    hashCode = hashCode * 59 + this.Phone.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
