/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo
    /// </summary>
    [DataContract]
        public partial class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo :  IEquatable<QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo" /> class.
        /// </summary>
        /// <param name="contactEmail">contactEmail.</param>
        /// <param name="contactName">contactName.</param>
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo(string contactEmail = default(string), string contactName = default(string))
        {
            this.ContactEmail = contactEmail;
            this.ContactName = contactName;
        }
        
        /// <summary>
        /// Gets or Sets ContactEmail
        /// </summary>
        [DataMember(Name="contactEmail", EmitDefaultValue=false)]
        public string ContactEmail { get; set; }

        /// <summary>
        /// Gets or Sets ContactName
        /// </summary>
        [DataMember(Name="contactName", EmitDefaultValue=false)]
        public string ContactName { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo {\n");
            sb.Append("  ContactEmail: ").Append(ContactEmail).Append("\n");
            sb.Append("  ContactName: ").Append(ContactName).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo);
        }

        /// <summary>
        /// Returns true if QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ContactEmail == input.ContactEmail ||
                    (this.ContactEmail != null &&
                    this.ContactEmail.Equals(input.ContactEmail))
                ) && 
                (
                    this.ContactName == input.ContactName ||
                    (this.ContactName != null &&
                    this.ContactName.Equals(input.ContactName))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ContactEmail != null)
                    hashCode = hashCode * 59 + this.ContactEmail.GetHashCode();
                if (this.ContactName != null)
                    hashCode = hashCode * 59 + this.ContactName.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
