/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser
    /// </summary>
    [DataContract]
        public partial class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser :  IEquatable<QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser" /> class.
        /// </summary>
        /// <param name="endUserName">endUserName.</param>
        /// <param name="endUserAddress">endUserAddress.</param>
        /// <param name="endUserAddress2">endUserAddress2.</param>
        /// <param name="endUserAddress3">endUserAddress3.</param>
        /// <param name="endUserCity">endUserCity.</param>
        /// <param name="endUserState">endUserState.</param>
        /// <param name="endUserEmail">endUserEmail.</param>
        /// <param name="endUserPhone">endUserPhone.</param>
        /// <param name="endUserZipCode">endUserZipCode.</param>
        /// <param name="endUserContactName">endUserContactName.</param>
        /// <param name="endUserMarketSegment">endUserMarketSegment.</param>
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser(string endUserName = default(string), string endUserAddress = default(string), string endUserAddress2 = default(string), string endUserAddress3 = default(string), string endUserCity = default(string), string endUserState = default(string), string endUserEmail = default(string), string endUserPhone = default(string), string endUserZipCode = default(string), string endUserContactName = default(string), string endUserMarketSegment = default(string))
        {
            this.EndUserName = endUserName;
            this.EndUserAddress = endUserAddress;
            this.EndUserAddress2 = endUserAddress2;
            this.EndUserAddress3 = endUserAddress3;
            this.EndUserCity = endUserCity;
            this.EndUserState = endUserState;
            this.EndUserEmail = endUserEmail;
            this.EndUserPhone = endUserPhone;
            this.EndUserZipCode = endUserZipCode;
            this.EndUserContactName = endUserContactName;
            this.EndUserMarketSegment = endUserMarketSegment;
        }
        
        /// <summary>
        /// Gets or Sets EndUserName
        /// </summary>
        [DataMember(Name="endUserName", EmitDefaultValue=false)]
        public string EndUserName { get; set; }

        /// <summary>
        /// Gets or Sets EndUserAddress
        /// </summary>
        [DataMember(Name="endUserAddress", EmitDefaultValue=false)]
        public string EndUserAddress { get; set; }

        /// <summary>
        /// Gets or Sets EndUserAddress2
        /// </summary>
        [DataMember(Name="endUserAddress2", EmitDefaultValue=false)]
        public string EndUserAddress2 { get; set; }

        /// <summary>
        /// Gets or Sets EndUserAddress3
        /// </summary>
        [DataMember(Name="endUserAddress3", EmitDefaultValue=false)]
        public string EndUserAddress3 { get; set; }

        /// <summary>
        /// Gets or Sets EndUserCity
        /// </summary>
        [DataMember(Name="endUserCity", EmitDefaultValue=false)]
        public string EndUserCity { get; set; }

        /// <summary>
        /// Gets or Sets EndUserState
        /// </summary>
        [DataMember(Name="endUserState", EmitDefaultValue=false)]
        public string EndUserState { get; set; }

        /// <summary>
        /// Gets or Sets EndUserEmail
        /// </summary>
        [DataMember(Name="endUserEmail", EmitDefaultValue=false)]
        public string EndUserEmail { get; set; }

        /// <summary>
        /// Gets or Sets EndUserPhone
        /// </summary>
        [DataMember(Name="endUserPhone", EmitDefaultValue=false)]
        public string EndUserPhone { get; set; }

        /// <summary>
        /// Gets or Sets EndUserZipCode
        /// </summary>
        [DataMember(Name="endUserZipCode", EmitDefaultValue=false)]
        public string EndUserZipCode { get; set; }

        /// <summary>
        /// Gets or Sets EndUserContactName
        /// </summary>
        [DataMember(Name="endUserContactName", EmitDefaultValue=false)]
        public string EndUserContactName { get; set; }

        /// <summary>
        /// Gets or Sets EndUserMarketSegment
        /// </summary>
        [DataMember(Name="endUserMarketSegment", EmitDefaultValue=false)]
        public string EndUserMarketSegment { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser {\n");
            sb.Append("  EndUserName: ").Append(EndUserName).Append("\n");
            sb.Append("  EndUserAddress: ").Append(EndUserAddress).Append("\n");
            sb.Append("  EndUserAddress2: ").Append(EndUserAddress2).Append("\n");
            sb.Append("  EndUserAddress3: ").Append(EndUserAddress3).Append("\n");
            sb.Append("  EndUserCity: ").Append(EndUserCity).Append("\n");
            sb.Append("  EndUserState: ").Append(EndUserState).Append("\n");
            sb.Append("  EndUserEmail: ").Append(EndUserEmail).Append("\n");
            sb.Append("  EndUserPhone: ").Append(EndUserPhone).Append("\n");
            sb.Append("  EndUserZipCode: ").Append(EndUserZipCode).Append("\n");
            sb.Append("  EndUserContactName: ").Append(EndUserContactName).Append("\n");
            sb.Append("  EndUserMarketSegment: ").Append(EndUserMarketSegment).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser);
        }

        /// <summary>
        /// Returns true if QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.EndUserName == input.EndUserName ||
                    (this.EndUserName != null &&
                    this.EndUserName.Equals(input.EndUserName))
                ) && 
                (
                    this.EndUserAddress == input.EndUserAddress ||
                    (this.EndUserAddress != null &&
                    this.EndUserAddress.Equals(input.EndUserAddress))
                ) && 
                (
                    this.EndUserAddress2 == input.EndUserAddress2 ||
                    (this.EndUserAddress2 != null &&
                    this.EndUserAddress2.Equals(input.EndUserAddress2))
                ) && 
                (
                    this.EndUserAddress3 == input.EndUserAddress3 ||
                    (this.EndUserAddress3 != null &&
                    this.EndUserAddress3.Equals(input.EndUserAddress3))
                ) && 
                (
                    this.EndUserCity == input.EndUserCity ||
                    (this.EndUserCity != null &&
                    this.EndUserCity.Equals(input.EndUserCity))
                ) && 
                (
                    this.EndUserState == input.EndUserState ||
                    (this.EndUserState != null &&
                    this.EndUserState.Equals(input.EndUserState))
                ) && 
                (
                    this.EndUserEmail == input.EndUserEmail ||
                    (this.EndUserEmail != null &&
                    this.EndUserEmail.Equals(input.EndUserEmail))
                ) && 
                (
                    this.EndUserPhone == input.EndUserPhone ||
                    (this.EndUserPhone != null &&
                    this.EndUserPhone.Equals(input.EndUserPhone))
                ) && 
                (
                    this.EndUserZipCode == input.EndUserZipCode ||
                    (this.EndUserZipCode != null &&
                    this.EndUserZipCode.Equals(input.EndUserZipCode))
                ) && 
                (
                    this.EndUserContactName == input.EndUserContactName ||
                    (this.EndUserContactName != null &&
                    this.EndUserContactName.Equals(input.EndUserContactName))
                ) && 
                (
                    this.EndUserMarketSegment == input.EndUserMarketSegment ||
                    (this.EndUserMarketSegment != null &&
                    this.EndUserMarketSegment.Equals(input.EndUserMarketSegment))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.EndUserName != null)
                    hashCode = hashCode * 59 + this.EndUserName.GetHashCode();
                if (this.EndUserAddress != null)
                    hashCode = hashCode * 59 + this.EndUserAddress.GetHashCode();
                if (this.EndUserAddress2 != null)
                    hashCode = hashCode * 59 + this.EndUserAddress2.GetHashCode();
                if (this.EndUserAddress3 != null)
                    hashCode = hashCode * 59 + this.EndUserAddress3.GetHashCode();
                if (this.EndUserCity != null)
                    hashCode = hashCode * 59 + this.EndUserCity.GetHashCode();
                if (this.EndUserState != null)
                    hashCode = hashCode * 59 + this.EndUserState.GetHashCode();
                if (this.EndUserEmail != null)
                    hashCode = hashCode * 59 + this.EndUserEmail.GetHashCode();
                if (this.EndUserPhone != null)
                    hashCode = hashCode * 59 + this.EndUserPhone.GetHashCode();
                if (this.EndUserZipCode != null)
                    hashCode = hashCode * 59 + this.EndUserZipCode.GetHashCode();
                if (this.EndUserContactName != null)
                    hashCode = hashCode * 59 + this.EndUserContactName.GetHashCode();
                if (this.EndUserMarketSegment != null)
                    hashCode = hashCode * 59 + this.EndUserMarketSegment.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
