/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes
    /// </summary>
    [DataContract]
        public partial class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes :  IEquatable<QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes" /> class.
        /// </summary>
        /// <param name="estimateId">estimateId.</param>
        /// <param name="dealId">dealId.</param>
        /// <param name="vendorName">vendorName.</param>
        /// <param name="vendorSettingMessage">vendorSettingMessage.</param>
        public QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes(string estimateId = default(string), string dealId = default(string), string vendorName = default(string), string vendorSettingMessage = default(string))
        {
            this.EstimateId = estimateId;
            this.DealId = dealId;
            this.VendorName = vendorName;
            this.VendorSettingMessage = vendorSettingMessage;
        }
        
        /// <summary>
        /// Gets or Sets EstimateId
        /// </summary>
        [DataMember(Name="estimateId", EmitDefaultValue=false)]
        public string EstimateId { get; set; }

        /// <summary>
        /// Gets or Sets DealId
        /// </summary>
        [DataMember(Name="dealId", EmitDefaultValue=false)]
        public string DealId { get; set; }

        /// <summary>
        /// Gets or Sets VendorName
        /// </summary>
        [DataMember(Name="vendorName", EmitDefaultValue=false)]
        public string VendorName { get; set; }

        /// <summary>
        /// Gets or Sets VendorSettingMessage
        /// </summary>
        [DataMember(Name="vendorSettingMessage", EmitDefaultValue=false)]
        public string VendorSettingMessage { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes {\n");
            sb.Append("  EstimateId: ").Append(EstimateId).Append("\n");
            sb.Append("  DealId: ").Append(DealId).Append("\n");
            sb.Append("  VendorName: ").Append(VendorName).Append("\n");
            sb.Append("  VendorSettingMessage: ").Append(VendorSettingMessage).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes);
        }

        /// <summary>
        /// Returns true if QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.EstimateId == input.EstimateId ||
                    (this.EstimateId != null &&
                    this.EstimateId.Equals(input.EstimateId))
                ) && 
                (
                    this.DealId == input.DealId ||
                    (this.DealId != null &&
                    this.DealId.Equals(input.DealId))
                ) && 
                (
                    this.VendorName == input.VendorName ||
                    (this.VendorName != null &&
                    this.VendorName.Equals(input.VendorName))
                ) && 
                (
                    this.VendorSettingMessage == input.VendorSettingMessage ||
                    (this.VendorSettingMessage != null &&
                    this.VendorSettingMessage.Equals(input.VendorSettingMessage))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.EstimateId != null)
                    hashCode = hashCode * 59 + this.EstimateId.GetHashCode();
                if (this.DealId != null)
                    hashCode = hashCode * 59 + this.DealId.GetHashCode();
                if (this.VendorName != null)
                    hashCode = hashCode * 59 + this.VendorName.GetHashCode();
                if (this.VendorSettingMessage != null)
                    hashCode = hashCode * 59 + this.VendorSettingMessage.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
