/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteDetailsRequestQuoteProductsRequest
    /// </summary>
    [DataContract]
        public partial class QuoteDetailsRequestQuoteProductsRequest :  IEquatable<QuoteDetailsRequestQuoteProductsRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetailsRequestQuoteProductsRequest" /> class.
        /// </summary>
        /// <param name="requestpreamble">requestpreamble.</param>
        /// <param name="retrieveQuoteProductsRequest">retrieveQuoteProductsRequest.</param>
        public QuoteDetailsRequestQuoteProductsRequest(QuoteDetailsRequestQuoteProductsRequestRequestpreamble requestpreamble = default(QuoteDetailsRequestQuoteProductsRequestRequestpreamble), QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest retrieveQuoteProductsRequest = default(QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest))
        {
            this.Requestpreamble = requestpreamble;
            this.RetrieveQuoteProductsRequest = retrieveQuoteProductsRequest;
        }
        
        /// <summary>
        /// Gets or Sets Requestpreamble
        /// </summary>
        [DataMember(Name="requestpreamble", EmitDefaultValue=false)]
        public QuoteDetailsRequestQuoteProductsRequestRequestpreamble Requestpreamble { get; set; }

        /// <summary>
        /// Gets or Sets RetrieveQuoteProductsRequest
        /// </summary>
        [DataMember(Name="retrieveQuoteProductsRequest", EmitDefaultValue=false)]
        public QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest RetrieveQuoteProductsRequest { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetailsRequestQuoteProductsRequest {\n");
            sb.Append("  Requestpreamble: ").Append(Requestpreamble).Append("\n");
            sb.Append("  RetrieveQuoteProductsRequest: ").Append(RetrieveQuoteProductsRequest).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetailsRequestQuoteProductsRequest);
        }

        /// <summary>
        /// Returns true if QuoteDetailsRequestQuoteProductsRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetailsRequestQuoteProductsRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetailsRequestQuoteProductsRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Requestpreamble == input.Requestpreamble ||
                    (this.Requestpreamble != null &&
                    this.Requestpreamble.Equals(input.Requestpreamble))
                ) && 
                (
                    this.RetrieveQuoteProductsRequest == input.RetrieveQuoteProductsRequest ||
                    (this.RetrieveQuoteProductsRequest != null &&
                    this.RetrieveQuoteProductsRequest.Equals(input.RetrieveQuoteProductsRequest))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Requestpreamble != null)
                    hashCode = hashCode * 59 + this.Requestpreamble.GetHashCode();
                if (this.RetrieveQuoteProductsRequest != null)
                    hashCode = hashCode * 59 + this.RetrieveQuoteProductsRequest.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
