/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest
    /// </summary>
    [DataContract]
        public partial class QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest :  IEquatable<QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest" /> class.
        /// </summary>
        /// <param name="quoteNumber">Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes..</param>
        /// <param name="thirdPartySource">Unique identifier used to identify the third party source accessing the services..</param>
        public QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest(string quoteNumber = default(string), string thirdPartySource = default(string))
        {
            this.QuoteNumber = quoteNumber;
            this.ThirdPartySource = thirdPartySource;
        }
        
        /// <summary>
        /// Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.
        /// </summary>
        /// <value>Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.</value>
        [DataMember(Name="quoteNumber", EmitDefaultValue=false)]
        public string QuoteNumber { get; set; }

        /// <summary>
        /// Unique identifier used to identify the third party source accessing the services.
        /// </summary>
        /// <value>Unique identifier used to identify the third party source accessing the services.</value>
        [DataMember(Name="thirdPartySource", EmitDefaultValue=false)]
        public string ThirdPartySource { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest {\n");
            sb.Append("  QuoteNumber: ").Append(QuoteNumber).Append("\n");
            sb.Append("  ThirdPartySource: ").Append(ThirdPartySource).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest);
        }

        /// <summary>
        /// Returns true if QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.QuoteNumber == input.QuoteNumber ||
                    (this.QuoteNumber != null &&
                    this.QuoteNumber.Equals(input.QuoteNumber))
                ) && 
                (
                    this.ThirdPartySource == input.ThirdPartySource ||
                    (this.ThirdPartySource != null &&
                    this.ThirdPartySource.Equals(input.ThirdPartySource))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.QuoteNumber != null)
                    hashCode = hashCode * 59 + this.QuoteNumber.GetHashCode();
                if (this.ThirdPartySource != null)
                    hashCode = hashCode * 59 + this.ThirdPartySource.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
