/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteListRequestQuoteSearchRequest
    /// </summary>
    [DataContract]
        public partial class QuoteListRequestQuoteSearchRequest :  IEquatable<QuoteListRequestQuoteSearchRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteListRequestQuoteSearchRequest" /> class.
        /// </summary>
        /// <param name="requestPreamble">requestPreamble.</param>
        /// <param name="retrieveQuoteRequest">retrieveQuoteRequest.</param>
        public QuoteListRequestQuoteSearchRequest(QuoteListRequestQuoteSearchRequestRequestPreamble requestPreamble = default(QuoteListRequestQuoteSearchRequestRequestPreamble), QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest retrieveQuoteRequest = default(QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest))
        {
            this.RequestPreamble = requestPreamble;
            this.RetrieveQuoteRequest = retrieveQuoteRequest;
        }
        
        /// <summary>
        /// Gets or Sets RequestPreamble
        /// </summary>
        [DataMember(Name="requestPreamble", EmitDefaultValue=false)]
        public QuoteListRequestQuoteSearchRequestRequestPreamble RequestPreamble { get; set; }

        /// <summary>
        /// Gets or Sets RetrieveQuoteRequest
        /// </summary>
        [DataMember(Name="retrieveQuoteRequest", EmitDefaultValue=false)]
        public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest RetrieveQuoteRequest { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteListRequestQuoteSearchRequest {\n");
            sb.Append("  RequestPreamble: ").Append(RequestPreamble).Append("\n");
            sb.Append("  RetrieveQuoteRequest: ").Append(RetrieveQuoteRequest).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteListRequestQuoteSearchRequest);
        }

        /// <summary>
        /// Returns true if QuoteListRequestQuoteSearchRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteListRequestQuoteSearchRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteListRequestQuoteSearchRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.RequestPreamble == input.RequestPreamble ||
                    (this.RequestPreamble != null &&
                    this.RequestPreamble.Equals(input.RequestPreamble))
                ) && 
                (
                    this.RetrieveQuoteRequest == input.RetrieveQuoteRequest ||
                    (this.RetrieveQuoteRequest != null &&
                    this.RetrieveQuoteRequest.Equals(input.RetrieveQuoteRequest))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RequestPreamble != null)
                    hashCode = hashCode * 59 + this.RequestPreamble.GetHashCode();
                if (this.RetrieveQuoteRequest != null)
                    hashCode = hashCode * 59 + this.RetrieveQuoteRequest.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
