/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteListRequestQuoteSearchRequestRequestPreamble
    /// </summary>
    [DataContract]
        public partial class QuoteListRequestQuoteSearchRequestRequestPreamble :  IEquatable<QuoteListRequestQuoteSearchRequestRequestPreamble>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteListRequestQuoteSearchRequestRequestPreamble" /> class.
        /// </summary>
        /// <param name="customerNumber">Reseller Number (referred to as the account BCN) is the unique identifier for an Ingram Micro customer account. (required).</param>
        /// <param name="customerContact">Logged in User&#x27;s email address..</param>
        /// <param name="isoCountryCode">The ISO country codes are internationally recognized codes designated for each country represented by a two-letter combination (alpha-2). (required).</param>
        public QuoteListRequestQuoteSearchRequestRequestPreamble(string customerNumber = default(string), string customerContact = default(string), string isoCountryCode = default(string))
        {
            // to ensure "customerNumber" is required (not null)
            if (customerNumber == null)
            {
                throw new InvalidDataException("customerNumber is a required property for QuoteListRequestQuoteSearchRequestRequestPreamble and cannot be null");
            }
            else
            {
                this.CustomerNumber = customerNumber;
            }
            // to ensure "isoCountryCode" is required (not null)
            if (isoCountryCode == null)
            {
                throw new InvalidDataException("isoCountryCode is a required property for QuoteListRequestQuoteSearchRequestRequestPreamble and cannot be null");
            }
            else
            {
                this.IsoCountryCode = isoCountryCode;
            }
            this.CustomerContact = customerContact;
        }
        
        /// <summary>
        /// Reseller Number (referred to as the account BCN) is the unique identifier for an Ingram Micro customer account.
        /// </summary>
        /// <value>Reseller Number (referred to as the account BCN) is the unique identifier for an Ingram Micro customer account.</value>
        [DataMember(Name="customerNumber", EmitDefaultValue=false)]
        public string CustomerNumber { get; set; }

        /// <summary>
        /// Logged in User&#x27;s email address.
        /// </summary>
        /// <value>Logged in User&#x27;s email address.</value>
        [DataMember(Name="customerContact", EmitDefaultValue=false)]
        public string CustomerContact { get; set; }

        /// <summary>
        /// The ISO country codes are internationally recognized codes designated for each country represented by a two-letter combination (alpha-2).
        /// </summary>
        /// <value>The ISO country codes are internationally recognized codes designated for each country represented by a two-letter combination (alpha-2).</value>
        [DataMember(Name="isoCountryCode", EmitDefaultValue=false)]
        public string IsoCountryCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteListRequestQuoteSearchRequestRequestPreamble {\n");
            sb.Append("  CustomerNumber: ").Append(CustomerNumber).Append("\n");
            sb.Append("  CustomerContact: ").Append(CustomerContact).Append("\n");
            sb.Append("  IsoCountryCode: ").Append(IsoCountryCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteListRequestQuoteSearchRequestRequestPreamble);
        }

        /// <summary>
        /// Returns true if QuoteListRequestQuoteSearchRequestRequestPreamble instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteListRequestQuoteSearchRequestRequestPreamble to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteListRequestQuoteSearchRequestRequestPreamble input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CustomerNumber == input.CustomerNumber ||
                    (this.CustomerNumber != null &&
                    this.CustomerNumber.Equals(input.CustomerNumber))
                ) && 
                (
                    this.CustomerContact == input.CustomerContact ||
                    (this.CustomerContact != null &&
                    this.CustomerContact.Equals(input.CustomerContact))
                ) && 
                (
                    this.IsoCountryCode == input.IsoCountryCode ||
                    (this.IsoCountryCode != null &&
                    this.IsoCountryCode.Equals(input.IsoCountryCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CustomerNumber != null)
                    hashCode = hashCode * 59 + this.CustomerNumber.GetHashCode();
                if (this.CustomerContact != null)
                    hashCode = hashCode * 59 + this.CustomerContact.GetHashCode();
                if (this.IsoCountryCode != null)
                    hashCode = hashCode * 59 + this.IsoCountryCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
