/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Response schema for get quote list endpoint
    /// </summary>
    [DataContract]
        public partial class QuoteListResponse :  IEquatable<QuoteListResponse>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteListResponse" /> class.
        /// </summary>
        /// <param name="quoteSearchResponse">quoteSearchResponse.</param>
        public QuoteListResponse(QuoteListResponseQuoteSearchResponse quoteSearchResponse = default(QuoteListResponseQuoteSearchResponse))
        {
            this.QuoteSearchResponse = quoteSearchResponse;
        }
        
        /// <summary>
        /// Gets or Sets QuoteSearchResponse
        /// </summary>
        [DataMember(Name="quoteSearchResponse", EmitDefaultValue=false)]
        public QuoteListResponseQuoteSearchResponse QuoteSearchResponse { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteListResponse {\n");
            sb.Append("  QuoteSearchResponse: ").Append(QuoteSearchResponse).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteListResponse);
        }

        /// <summary>
        /// Returns true if QuoteListResponse instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteListResponse to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteListResponse input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.QuoteSearchResponse == input.QuoteSearchResponse ||
                    (this.QuoteSearchResponse != null &&
                    this.QuoteSearchResponse.Equals(input.QuoteSearchResponse))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.QuoteSearchResponse != null)
                    hashCode = hashCode * 59 + this.QuoteSearchResponse.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
