/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteListResponseQuoteSearchResponse
    /// </summary>
    [DataContract]
        public partial class QuoteListResponseQuoteSearchResponse :  IEquatable<QuoteListResponseQuoteSearchResponse>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteListResponseQuoteSearchResponse" /> class.
        /// </summary>
        /// <param name="responsePreamble">responsePreamble.</param>
        /// <param name="quoteList">quoteList.</param>
        /// <param name="totalCount">Total count of quotes retrieved in the request response..</param>
        public QuoteListResponseQuoteSearchResponse(QuoteListResponseQuoteSearchResponseResponsePreamble responsePreamble = default(QuoteListResponseQuoteSearchResponseResponsePreamble), List<QuoteListResponseQuoteSearchResponseQuoteList> quoteList = default(List<QuoteListResponseQuoteSearchResponseQuoteList>), int? totalCount = default(int?))
        {
            this.ResponsePreamble = responsePreamble;
            this.QuoteList = quoteList;
            this.TotalCount = totalCount;
        }
        
        /// <summary>
        /// Gets or Sets ResponsePreamble
        /// </summary>
        [DataMember(Name="responsePreamble", EmitDefaultValue=false)]
        public QuoteListResponseQuoteSearchResponseResponsePreamble ResponsePreamble { get; set; }

        /// <summary>
        /// Gets or Sets QuoteList
        /// </summary>
        [DataMember(Name="quoteList", EmitDefaultValue=false)]
        public List<QuoteListResponseQuoteSearchResponseQuoteList> QuoteList { get; set; }

        /// <summary>
        /// Total count of quotes retrieved in the request response.
        /// </summary>
        /// <value>Total count of quotes retrieved in the request response.</value>
        [DataMember(Name="totalCount", EmitDefaultValue=false)]
        public int? TotalCount { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteListResponseQuoteSearchResponse {\n");
            sb.Append("  ResponsePreamble: ").Append(ResponsePreamble).Append("\n");
            sb.Append("  QuoteList: ").Append(QuoteList).Append("\n");
            sb.Append("  TotalCount: ").Append(TotalCount).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteListResponseQuoteSearchResponse);
        }

        /// <summary>
        /// Returns true if QuoteListResponseQuoteSearchResponse instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteListResponseQuoteSearchResponse to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteListResponseQuoteSearchResponse input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ResponsePreamble == input.ResponsePreamble ||
                    (this.ResponsePreamble != null &&
                    this.ResponsePreamble.Equals(input.ResponsePreamble))
                ) && 
                (
                    this.QuoteList == input.QuoteList ||
                    this.QuoteList != null &&
                    input.QuoteList != null &&
                    this.QuoteList.SequenceEqual(input.QuoteList)
                ) && 
                (
                    this.TotalCount == input.TotalCount ||
                    (this.TotalCount != null &&
                    this.TotalCount.Equals(input.TotalCount))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ResponsePreamble != null)
                    hashCode = hashCode * 59 + this.ResponsePreamble.GetHashCode();
                if (this.QuoteList != null)
                    hashCode = hashCode * 59 + this.QuoteList.GetHashCode();
                if (this.TotalCount != null)
                    hashCode = hashCode * 59 + this.TotalCount.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
