/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteListResponseQuoteSearchResponseQuoteList
    /// </summary>
    [DataContract]
        public partial class QuoteListResponseQuoteSearchResponseQuoteList :  IEquatable<QuoteListResponseQuoteSearchResponseQuoteList>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteListResponseQuoteSearchResponseQuoteList" /> class.
        /// </summary>
        /// <param name="quoteGuid">Quote GUID is the primary quote key in Ingram Micro&#x27;s CRM - needed to retrieve quote details..</param>
        /// <param name="quoteName">Quote Name given to quote by sales team or system generated. Generally used as a reference to identify the quote..</param>
        /// <param name="quoteNumber">Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes..</param>
        /// <param name="revisionNumber">When a quote has been revised and updated, the quote number remains the same throughout the lifecycle of the quote, however, a Revision number is updated for each revision of the quote. The revision numbers is associated with the Unique Quote Number..</param>
        /// <param name="endUserName">End User Name is the end customer name that is associated with a quote in Ingram Micro&#x27;s CRM.</param>
        /// <param name="bidNumber">Special Pricing Bid Number, also refers to as Dart Number relates to a unique pricing deal associated with a vendor for the quote..</param>
        /// <param name="totalAmount">Total amount of quoted price for all products in the quote..</param>
        /// <param name="quoteStatus">This refers to the primary status of the quote. API responses will return: Active.</param>
        /// <param name="createdDate">Date the Quote was initially Created.</param>
        /// <param name="lastModifiedDate">Date the Quote was last updated or modified..</param>
        /// <param name="quoteExpiryDate">Date the Quote Expires.</param>
        public QuoteListResponseQuoteSearchResponseQuoteList(string quoteGuid = default(string), string quoteName = default(string), string quoteNumber = default(string), int? revisionNumber = default(int?), string endUserName = default(string), string bidNumber = default(string), string totalAmount = default(string), string quoteStatus = default(string), DateTime? createdDate = default(DateTime?), DateTime? lastModifiedDate = default(DateTime?), DateTime? quoteExpiryDate = default(DateTime?))
        {
            this.QuoteGuid = quoteGuid;
            this.QuoteName = quoteName;
            this.QuoteNumber = quoteNumber;
            this.RevisionNumber = revisionNumber;
            this.EndUserName = endUserName;
            this.BidNumber = bidNumber;
            this.TotalAmount = totalAmount;
            this.QuoteStatus = quoteStatus;
            this.CreatedDate = createdDate;
            this.LastModifiedDate = lastModifiedDate;
            this.QuoteExpiryDate = quoteExpiryDate;
        }
        
        /// <summary>
        /// Quote GUID is the primary quote key in Ingram Micro&#x27;s CRM - needed to retrieve quote details.
        /// </summary>
        /// <value>Quote GUID is the primary quote key in Ingram Micro&#x27;s CRM - needed to retrieve quote details.</value>
        [DataMember(Name="quoteGuid", EmitDefaultValue=false)]
        public string QuoteGuid { get; set; }

        /// <summary>
        /// Quote Name given to quote by sales team or system generated. Generally used as a reference to identify the quote.
        /// </summary>
        /// <value>Quote Name given to quote by sales team or system generated. Generally used as a reference to identify the quote.</value>
        [DataMember(Name="quoteName", EmitDefaultValue=false)]
        public string QuoteName { get; set; }

        /// <summary>
        /// Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.
        /// </summary>
        /// <value>Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.</value>
        [DataMember(Name="quoteNumber", EmitDefaultValue=false)]
        public string QuoteNumber { get; set; }

        /// <summary>
        /// When a quote has been revised and updated, the quote number remains the same throughout the lifecycle of the quote, however, a Revision number is updated for each revision of the quote. The revision numbers is associated with the Unique Quote Number.
        /// </summary>
        /// <value>When a quote has been revised and updated, the quote number remains the same throughout the lifecycle of the quote, however, a Revision number is updated for each revision of the quote. The revision numbers is associated with the Unique Quote Number.</value>
        [DataMember(Name="revisionNumber", EmitDefaultValue=false)]
        public int? RevisionNumber { get; set; }

        /// <summary>
        /// End User Name is the end customer name that is associated with a quote in Ingram Micro&#x27;s CRM
        /// </summary>
        /// <value>End User Name is the end customer name that is associated with a quote in Ingram Micro&#x27;s CRM</value>
        [DataMember(Name="endUserName", EmitDefaultValue=false)]
        public string EndUserName { get; set; }

        /// <summary>
        /// Special Pricing Bid Number, also refers to as Dart Number relates to a unique pricing deal associated with a vendor for the quote.
        /// </summary>
        /// <value>Special Pricing Bid Number, also refers to as Dart Number relates to a unique pricing deal associated with a vendor for the quote.</value>
        [DataMember(Name="bidNumber", EmitDefaultValue=false)]
        public string BidNumber { get; set; }

        /// <summary>
        /// Total amount of quoted price for all products in the quote.
        /// </summary>
        /// <value>Total amount of quoted price for all products in the quote.</value>
        [DataMember(Name="totalAmount", EmitDefaultValue=false)]
        public string TotalAmount { get; set; }

        /// <summary>
        /// This refers to the primary status of the quote. API responses will return: Active
        /// </summary>
        /// <value>This refers to the primary status of the quote. API responses will return: Active</value>
        [DataMember(Name="quoteStatus", EmitDefaultValue=false)]
        public string QuoteStatus { get; set; }

        /// <summary>
        /// Date the Quote was initially Created
        /// </summary>
        /// <value>Date the Quote was initially Created</value>
        [DataMember(Name="createdDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? CreatedDate { get; set; }

        /// <summary>
        /// Date the Quote was last updated or modified.
        /// </summary>
        /// <value>Date the Quote was last updated or modified.</value>
        [DataMember(Name="lastModifiedDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? LastModifiedDate { get; set; }

        /// <summary>
        /// Date the Quote Expires
        /// </summary>
        /// <value>Date the Quote Expires</value>
        [DataMember(Name="quoteExpiryDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? QuoteExpiryDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteListResponseQuoteSearchResponseQuoteList {\n");
            sb.Append("  QuoteGuid: ").Append(QuoteGuid).Append("\n");
            sb.Append("  QuoteName: ").Append(QuoteName).Append("\n");
            sb.Append("  QuoteNumber: ").Append(QuoteNumber).Append("\n");
            sb.Append("  RevisionNumber: ").Append(RevisionNumber).Append("\n");
            sb.Append("  EndUserName: ").Append(EndUserName).Append("\n");
            sb.Append("  BidNumber: ").Append(BidNumber).Append("\n");
            sb.Append("  TotalAmount: ").Append(TotalAmount).Append("\n");
            sb.Append("  QuoteStatus: ").Append(QuoteStatus).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  LastModifiedDate: ").Append(LastModifiedDate).Append("\n");
            sb.Append("  QuoteExpiryDate: ").Append(QuoteExpiryDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteListResponseQuoteSearchResponseQuoteList);
        }

        /// <summary>
        /// Returns true if QuoteListResponseQuoteSearchResponseQuoteList instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteListResponseQuoteSearchResponseQuoteList to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteListResponseQuoteSearchResponseQuoteList input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.QuoteGuid == input.QuoteGuid ||
                    (this.QuoteGuid != null &&
                    this.QuoteGuid.Equals(input.QuoteGuid))
                ) && 
                (
                    this.QuoteName == input.QuoteName ||
                    (this.QuoteName != null &&
                    this.QuoteName.Equals(input.QuoteName))
                ) && 
                (
                    this.QuoteNumber == input.QuoteNumber ||
                    (this.QuoteNumber != null &&
                    this.QuoteNumber.Equals(input.QuoteNumber))
                ) && 
                (
                    this.RevisionNumber == input.RevisionNumber ||
                    (this.RevisionNumber != null &&
                    this.RevisionNumber.Equals(input.RevisionNumber))
                ) && 
                (
                    this.EndUserName == input.EndUserName ||
                    (this.EndUserName != null &&
                    this.EndUserName.Equals(input.EndUserName))
                ) && 
                (
                    this.BidNumber == input.BidNumber ||
                    (this.BidNumber != null &&
                    this.BidNumber.Equals(input.BidNumber))
                ) && 
                (
                    this.TotalAmount == input.TotalAmount ||
                    (this.TotalAmount != null &&
                    this.TotalAmount.Equals(input.TotalAmount))
                ) && 
                (
                    this.QuoteStatus == input.QuoteStatus ||
                    (this.QuoteStatus != null &&
                    this.QuoteStatus.Equals(input.QuoteStatus))
                ) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && 
                (
                    this.LastModifiedDate == input.LastModifiedDate ||
                    (this.LastModifiedDate != null &&
                    this.LastModifiedDate.Equals(input.LastModifiedDate))
                ) && 
                (
                    this.QuoteExpiryDate == input.QuoteExpiryDate ||
                    (this.QuoteExpiryDate != null &&
                    this.QuoteExpiryDate.Equals(input.QuoteExpiryDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.QuoteGuid != null)
                    hashCode = hashCode * 59 + this.QuoteGuid.GetHashCode();
                if (this.QuoteName != null)
                    hashCode = hashCode * 59 + this.QuoteName.GetHashCode();
                if (this.QuoteNumber != null)
                    hashCode = hashCode * 59 + this.QuoteNumber.GetHashCode();
                if (this.RevisionNumber != null)
                    hashCode = hashCode * 59 + this.RevisionNumber.GetHashCode();
                if (this.EndUserName != null)
                    hashCode = hashCode * 59 + this.EndUserName.GetHashCode();
                if (this.BidNumber != null)
                    hashCode = hashCode * 59 + this.BidNumber.GetHashCode();
                if (this.TotalAmount != null)
                    hashCode = hashCode * 59 + this.TotalAmount.GetHashCode();
                if (this.QuoteStatus != null)
                    hashCode = hashCode * 59 + this.QuoteStatus.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.LastModifiedDate != null)
                    hashCode = hashCode * 59 + this.LastModifiedDate.GetHashCode();
                if (this.QuoteExpiryDate != null)
                    hashCode = hashCode * 59 + this.QuoteExpiryDate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
