/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteListResponseQuoteSearchResponseResponsePreamble
    /// </summary>
    [DataContract]
        public partial class QuoteListResponseQuoteSearchResponseResponsePreamble :  IEquatable<QuoteListResponseQuoteSearchResponseResponsePreamble>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteListResponseQuoteSearchResponseResponsePreamble" /> class.
        /// </summary>
        /// <param name="responseStatus">Status of the Request - \&quot;Passed\&quot;, \&quot;Failed\&quot;.</param>
        /// <param name="responseStatusCode">responseStatusCode is the code returned in response to a request. The following Codes are returned: 200 400 500.</param>
        /// <param name="responseMessage">200 &#x3D; Action was successfully received, understood and accepted. 400 &#x3D; The request contains bad syntax or can not be fullfilled. This means there is a problem with the request. 500 &#x3D; The server failed to fulfill an apparently valid request. This is a temporary problem, the request should be resubmitted..</param>
        public QuoteListResponseQuoteSearchResponseResponsePreamble(string responseStatus = default(string), string responseStatusCode = default(string), string responseMessage = default(string))
        {
            this.ResponseStatus = responseStatus;
            this.ResponseStatusCode = responseStatusCode;
            this.ResponseMessage = responseMessage;
        }
        
        /// <summary>
        /// Status of the Request - \&quot;Passed\&quot;, \&quot;Failed\&quot;
        /// </summary>
        /// <value>Status of the Request - \&quot;Passed\&quot;, \&quot;Failed\&quot;</value>
        [DataMember(Name="responseStatus", EmitDefaultValue=false)]
        public string ResponseStatus { get; set; }

        /// <summary>
        /// responseStatusCode is the code returned in response to a request. The following Codes are returned: 200 400 500
        /// </summary>
        /// <value>responseStatusCode is the code returned in response to a request. The following Codes are returned: 200 400 500</value>
        [DataMember(Name="responseStatusCode", EmitDefaultValue=false)]
        public string ResponseStatusCode { get; set; }

        /// <summary>
        /// 200 &#x3D; Action was successfully received, understood and accepted. 400 &#x3D; The request contains bad syntax or can not be fullfilled. This means there is a problem with the request. 500 &#x3D; The server failed to fulfill an apparently valid request. This is a temporary problem, the request should be resubmitted.
        /// </summary>
        /// <value>200 &#x3D; Action was successfully received, understood and accepted. 400 &#x3D; The request contains bad syntax or can not be fullfilled. This means there is a problem with the request. 500 &#x3D; The server failed to fulfill an apparently valid request. This is a temporary problem, the request should be resubmitted.</value>
        [DataMember(Name="responseMessage", EmitDefaultValue=false)]
        public string ResponseMessage { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteListResponseQuoteSearchResponseResponsePreamble {\n");
            sb.Append("  ResponseStatus: ").Append(ResponseStatus).Append("\n");
            sb.Append("  ResponseStatusCode: ").Append(ResponseStatusCode).Append("\n");
            sb.Append("  ResponseMessage: ").Append(ResponseMessage).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteListResponseQuoteSearchResponseResponsePreamble);
        }

        /// <summary>
        /// Returns true if QuoteListResponseQuoteSearchResponseResponsePreamble instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteListResponseQuoteSearchResponseResponsePreamble to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteListResponseQuoteSearchResponseResponsePreamble input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ResponseStatus == input.ResponseStatus ||
                    (this.ResponseStatus != null &&
                    this.ResponseStatus.Equals(input.ResponseStatus))
                ) && 
                (
                    this.ResponseStatusCode == input.ResponseStatusCode ||
                    (this.ResponseStatusCode != null &&
                    this.ResponseStatusCode.Equals(input.ResponseStatusCode))
                ) && 
                (
                    this.ResponseMessage == input.ResponseMessage ||
                    (this.ResponseMessage != null &&
                    this.ResponseMessage.Equals(input.ResponseMessage))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ResponseStatus != null)
                    hashCode = hashCode * 59 + this.ResponseStatus.GetHashCode();
                if (this.ResponseStatusCode != null)
                    hashCode = hashCode * 59 + this.ResponseStatusCode.GetHashCode();
                if (this.ResponseMessage != null)
                    hashCode = hashCode * 59 + this.ResponseMessage.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
