/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteProductList
    /// </summary>
    [DataContract]
        public partial class QuoteProductList :  IEquatable<QuoteProductList>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteProductList" /> class.
        /// </summary>
        /// <param name="quoteProductGuid">quoteProductGuid.</param>
        /// <param name="quantity">quantity.</param>
        /// <param name="comments">comments.</param>
        /// <param name="bidStartDate">bidStartDate.</param>
        /// <param name="bidExpiryDate">bidExpiryDate.</param>
        /// <param name="sku">sku.</param>
        /// <param name="lineNumber">lineNumber.</param>
        /// <param name="description">description.</param>
        /// <param name="vendorPartNumber">vendorPartNumber.</param>
        /// <param name="weight">weight.</param>
        /// <param name="isSuggestionProduct">isSuggestionProduct.</param>
        /// <param name="vpnCategory">vpnCategory.</param>
        /// <param name="quoteProductsSupplierPartAuxiliaryId">quoteProductsSupplierPartAuxiliaryId.</param>
        /// <param name="quoteProductsVendor">quoteProductsVendor.</param>
        /// <param name="price">price.</param>
        public QuoteProductList(string quoteProductGuid = default(string), string quantity = default(string), string comments = default(string), string bidStartDate = default(string), string bidExpiryDate = default(string), string sku = default(string), string lineNumber = default(string), string description = default(string), string vendorPartNumber = default(string), string weight = default(string), string isSuggestionProduct = default(string), string vpnCategory = default(string), string quoteProductsSupplierPartAuxiliaryId = default(string), string quoteProductsVendor = default(string), QuoteProductListPrice price = default(QuoteProductListPrice))
        {
            this.QuoteProductGuid = quoteProductGuid;
            this.Quantity = quantity;
            this.Comments = comments;
            this.BidStartDate = bidStartDate;
            this.BidExpiryDate = bidExpiryDate;
            this.Sku = sku;
            this.LineNumber = lineNumber;
            this.Description = description;
            this.VendorPartNumber = vendorPartNumber;
            this.Weight = weight;
            this.IsSuggestionProduct = isSuggestionProduct;
            this.VpnCategory = vpnCategory;
            this.QuoteProductsSupplierPartAuxiliaryId = quoteProductsSupplierPartAuxiliaryId;
            this.QuoteProductsVendor = quoteProductsVendor;
            this.Price = price;
        }
        
        /// <summary>
        /// Gets or Sets QuoteProductGuid
        /// </summary>
        [DataMember(Name="quoteProductGuid", EmitDefaultValue=false)]
        public string QuoteProductGuid { get; set; }

        /// <summary>
        /// Gets or Sets Quantity
        /// </summary>
        [DataMember(Name="quantity", EmitDefaultValue=false)]
        public string Quantity { get; set; }

        /// <summary>
        /// Gets or Sets Comments
        /// </summary>
        [DataMember(Name="comments", EmitDefaultValue=false)]
        public string Comments { get; set; }

        /// <summary>
        /// Gets or Sets BidStartDate
        /// </summary>
        [DataMember(Name="bidStartDate", EmitDefaultValue=false)]
        public string BidStartDate { get; set; }

        /// <summary>
        /// Gets or Sets BidExpiryDate
        /// </summary>
        [DataMember(Name="bidExpiryDate", EmitDefaultValue=false)]
        public string BidExpiryDate { get; set; }

        /// <summary>
        /// Gets or Sets Sku
        /// </summary>
        [DataMember(Name="sku", EmitDefaultValue=false)]
        public string Sku { get; set; }

        /// <summary>
        /// Gets or Sets LineNumber
        /// </summary>
        [DataMember(Name="lineNumber", EmitDefaultValue=false)]
        public string LineNumber { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Gets or Sets VendorPartNumber
        /// </summary>
        [DataMember(Name="vendorPartNumber", EmitDefaultValue=false)]
        public string VendorPartNumber { get; set; }

        /// <summary>
        /// Gets or Sets Weight
        /// </summary>
        [DataMember(Name="weight", EmitDefaultValue=false)]
        public string Weight { get; set; }

        /// <summary>
        /// Gets or Sets IsSuggestionProduct
        /// </summary>
        [DataMember(Name="isSuggestionProduct", EmitDefaultValue=false)]
        public string IsSuggestionProduct { get; set; }

        /// <summary>
        /// Gets or Sets VpnCategory
        /// </summary>
        [DataMember(Name="vpnCategory", EmitDefaultValue=false)]
        public string VpnCategory { get; set; }

        /// <summary>
        /// Gets or Sets QuoteProductsSupplierPartAuxiliaryId
        /// </summary>
        [DataMember(Name="quoteProductsSupplierPartAuxiliaryId", EmitDefaultValue=false)]
        public string QuoteProductsSupplierPartAuxiliaryId { get; set; }

        /// <summary>
        /// Gets or Sets QuoteProductsVendor
        /// </summary>
        [DataMember(Name="quoteProductsVendor", EmitDefaultValue=false)]
        public string QuoteProductsVendor { get; set; }

        /// <summary>
        /// Gets or Sets Price
        /// </summary>
        [DataMember(Name="price", EmitDefaultValue=false)]
        public QuoteProductListPrice Price { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteProductList {\n");
            sb.Append("  QuoteProductGuid: ").Append(QuoteProductGuid).Append("\n");
            sb.Append("  Quantity: ").Append(Quantity).Append("\n");
            sb.Append("  Comments: ").Append(Comments).Append("\n");
            sb.Append("  BidStartDate: ").Append(BidStartDate).Append("\n");
            sb.Append("  BidExpiryDate: ").Append(BidExpiryDate).Append("\n");
            sb.Append("  Sku: ").Append(Sku).Append("\n");
            sb.Append("  LineNumber: ").Append(LineNumber).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  VendorPartNumber: ").Append(VendorPartNumber).Append("\n");
            sb.Append("  Weight: ").Append(Weight).Append("\n");
            sb.Append("  IsSuggestionProduct: ").Append(IsSuggestionProduct).Append("\n");
            sb.Append("  VpnCategory: ").Append(VpnCategory).Append("\n");
            sb.Append("  QuoteProductsSupplierPartAuxiliaryId: ").Append(QuoteProductsSupplierPartAuxiliaryId).Append("\n");
            sb.Append("  QuoteProductsVendor: ").Append(QuoteProductsVendor).Append("\n");
            sb.Append("  Price: ").Append(Price).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteProductList);
        }

        /// <summary>
        /// Returns true if QuoteProductList instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteProductList to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteProductList input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.QuoteProductGuid == input.QuoteProductGuid ||
                    (this.QuoteProductGuid != null &&
                    this.QuoteProductGuid.Equals(input.QuoteProductGuid))
                ) && 
                (
                    this.Quantity == input.Quantity ||
                    (this.Quantity != null &&
                    this.Quantity.Equals(input.Quantity))
                ) && 
                (
                    this.Comments == input.Comments ||
                    (this.Comments != null &&
                    this.Comments.Equals(input.Comments))
                ) && 
                (
                    this.BidStartDate == input.BidStartDate ||
                    (this.BidStartDate != null &&
                    this.BidStartDate.Equals(input.BidStartDate))
                ) && 
                (
                    this.BidExpiryDate == input.BidExpiryDate ||
                    (this.BidExpiryDate != null &&
                    this.BidExpiryDate.Equals(input.BidExpiryDate))
                ) && 
                (
                    this.Sku == input.Sku ||
                    (this.Sku != null &&
                    this.Sku.Equals(input.Sku))
                ) && 
                (
                    this.LineNumber == input.LineNumber ||
                    (this.LineNumber != null &&
                    this.LineNumber.Equals(input.LineNumber))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.VendorPartNumber == input.VendorPartNumber ||
                    (this.VendorPartNumber != null &&
                    this.VendorPartNumber.Equals(input.VendorPartNumber))
                ) && 
                (
                    this.Weight == input.Weight ||
                    (this.Weight != null &&
                    this.Weight.Equals(input.Weight))
                ) && 
                (
                    this.IsSuggestionProduct == input.IsSuggestionProduct ||
                    (this.IsSuggestionProduct != null &&
                    this.IsSuggestionProduct.Equals(input.IsSuggestionProduct))
                ) && 
                (
                    this.VpnCategory == input.VpnCategory ||
                    (this.VpnCategory != null &&
                    this.VpnCategory.Equals(input.VpnCategory))
                ) && 
                (
                    this.QuoteProductsSupplierPartAuxiliaryId == input.QuoteProductsSupplierPartAuxiliaryId ||
                    (this.QuoteProductsSupplierPartAuxiliaryId != null &&
                    this.QuoteProductsSupplierPartAuxiliaryId.Equals(input.QuoteProductsSupplierPartAuxiliaryId))
                ) && 
                (
                    this.QuoteProductsVendor == input.QuoteProductsVendor ||
                    (this.QuoteProductsVendor != null &&
                    this.QuoteProductsVendor.Equals(input.QuoteProductsVendor))
                ) && 
                (
                    this.Price == input.Price ||
                    (this.Price != null &&
                    this.Price.Equals(input.Price))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.QuoteProductGuid != null)
                    hashCode = hashCode * 59 + this.QuoteProductGuid.GetHashCode();
                if (this.Quantity != null)
                    hashCode = hashCode * 59 + this.Quantity.GetHashCode();
                if (this.Comments != null)
                    hashCode = hashCode * 59 + this.Comments.GetHashCode();
                if (this.BidStartDate != null)
                    hashCode = hashCode * 59 + this.BidStartDate.GetHashCode();
                if (this.BidExpiryDate != null)
                    hashCode = hashCode * 59 + this.BidExpiryDate.GetHashCode();
                if (this.Sku != null)
                    hashCode = hashCode * 59 + this.Sku.GetHashCode();
                if (this.LineNumber != null)
                    hashCode = hashCode * 59 + this.LineNumber.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.VendorPartNumber != null)
                    hashCode = hashCode * 59 + this.VendorPartNumber.GetHashCode();
                if (this.Weight != null)
                    hashCode = hashCode * 59 + this.Weight.GetHashCode();
                if (this.IsSuggestionProduct != null)
                    hashCode = hashCode * 59 + this.IsSuggestionProduct.GetHashCode();
                if (this.VpnCategory != null)
                    hashCode = hashCode * 59 + this.VpnCategory.GetHashCode();
                if (this.QuoteProductsSupplierPartAuxiliaryId != null)
                    hashCode = hashCode * 59 + this.QuoteProductsSupplierPartAuxiliaryId.GetHashCode();
                if (this.QuoteProductsVendor != null)
                    hashCode = hashCode * 59 + this.QuoteProductsVendor.GetHashCode();
                if (this.Price != null)
                    hashCode = hashCode * 59 + this.Price.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
