/* 
 * Quote Management APIs
 *
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QuoteProductListPrice
    /// </summary>
    [DataContract]
        public partial class QuoteProductListPrice :  IEquatable<QuoteProductListPrice>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QuoteProductListPrice" /> class.
        /// </summary>
        /// <param name="quotePrice">quotePrice.</param>
        /// <param name="msrp">msrp.</param>
        /// <param name="extendedMsrp">extendedMsrp.</param>
        /// <param name="extendedQuotePrice">extendedQuotePrice.</param>
        public QuoteProductListPrice(decimal? quotePrice = default(decimal?), decimal? msrp = default(decimal?), decimal? extendedMsrp = default(decimal?), decimal? extendedQuotePrice = default(decimal?))
        {
            this.QuotePrice = quotePrice;
            this.Msrp = msrp;
            this.ExtendedMsrp = extendedMsrp;
            this.ExtendedQuotePrice = extendedQuotePrice;
        }
        
        /// <summary>
        /// Gets or Sets QuotePrice
        /// </summary>
        [DataMember(Name="quotePrice", EmitDefaultValue=false)]
        public decimal? QuotePrice { get; set; }

        /// <summary>
        /// Gets or Sets Msrp
        /// </summary>
        [DataMember(Name="msrp", EmitDefaultValue=false)]
        public decimal? Msrp { get; set; }

        /// <summary>
        /// Gets or Sets ExtendedMsrp
        /// </summary>
        [DataMember(Name="extendedMsrp", EmitDefaultValue=false)]
        public decimal? ExtendedMsrp { get; set; }

        /// <summary>
        /// Gets or Sets ExtendedQuotePrice
        /// </summary>
        [DataMember(Name="extendedQuotePrice", EmitDefaultValue=false)]
        public decimal? ExtendedQuotePrice { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QuoteProductListPrice {\n");
            sb.Append("  QuotePrice: ").Append(QuotePrice).Append("\n");
            sb.Append("  Msrp: ").Append(Msrp).Append("\n");
            sb.Append("  ExtendedMsrp: ").Append(ExtendedMsrp).Append("\n");
            sb.Append("  ExtendedQuotePrice: ").Append(ExtendedQuotePrice).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as QuoteProductListPrice);
        }

        /// <summary>
        /// Returns true if QuoteProductListPrice instances are equal
        /// </summary>
        /// <param name="input">Instance of QuoteProductListPrice to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QuoteProductListPrice input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.QuotePrice == input.QuotePrice ||
                    (this.QuotePrice != null &&
                    this.QuotePrice.Equals(input.QuotePrice))
                ) && 
                (
                    this.Msrp == input.Msrp ||
                    (this.Msrp != null &&
                    this.Msrp.Equals(input.Msrp))
                ) && 
                (
                    this.ExtendedMsrp == input.ExtendedMsrp ||
                    (this.ExtendedMsrp != null &&
                    this.ExtendedMsrp.Equals(input.ExtendedMsrp))
                ) && 
                (
                    this.ExtendedQuotePrice == input.ExtendedQuotePrice ||
                    (this.ExtendedQuotePrice != null &&
                    this.ExtendedQuotePrice.Equals(input.ExtendedQuotePrice))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.QuotePrice != null)
                    hashCode = hashCode * 59 + this.QuotePrice.GetHashCode();
                if (this.Msrp != null)
                    hashCode = hashCode * 59 + this.Msrp.GetHashCode();
                if (this.ExtendedMsrp != null)
                    hashCode = hashCode * 59 + this.ExtendedMsrp.GetHashCode();
                if (this.ExtendedQuotePrice != null)
                    hashCode = hashCode * 59 + this.ExtendedQuotePrice.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
